package com.cultural.heritage.model.dto.clothesgrade;

import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;

import java.io.Serial;
import java.io.Serializable;
import java.math.BigDecimal;

@Data
@Schema(description = "服装等级添加请求体", requiredProperties = {"clothesType", "image", "minPrice", "maxPrice", "brief"})
public class ClothesGradeAddRequest implements Serializable {

    /**
     * 类别名称
     */
    @Schema(description = "类别名称", example = "简约风尚")
    private String clothesType;


    /**
     * 商品图片
     */
    @Schema(description = "商品图片", example = "http://xxx.png")
    private String image;


    /**
     * 最低价格
     */
    @Schema(description = "最低价格", example = "80.00")
    private BigDecimal minPrice;


    /**
     * 最高价格
     */
    @Schema(description = "最高价格", example = "160")
    private BigDecimal maxPrice;


    /**
     * 服装价位简介
     */
    @Schema(description = "服装价位简介", example = "传承非遗之美，简约演绎经典")
    private String brief;


    @Serial
    private static final long serialVersionUID = 1L;
}
