package com.cultural.heritage.model.dto.clothesinfo;

import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;

import java.io.Serial;
import java.io.Serializable;
import java.math.BigDecimal;


@Data
@Schema(description = "服装添加请求体", requiredProperties = {"name", "image", "effectImg", "intro", "price", "clothesType"})
public class ClothesInfoAddRequest implements Serializable {



    /**
     * 服装名称
     */
    @Schema(description = "服装名称", example = "彩绣菊花纹刺绣长袍")
    private String name;


    /**
     * 服装图片
     */
    @Schema(description = "服装图片", example = "https://www.xxx.jpg")
    private String image;


    /**
     * 服装效果图
     */
    @Schema(description = "服装效果图", example = "https://www.xxx.jpg;https://www.xxx.png")
    private String effectImg;


    /**
     * 服装简介
     */
    @Schema(description = "服装简介", example = "用上等丝绸，质地细腻、柔软且富有光泽，触感极佳。统手工刺绣技艺，每一针每一线都凝聚着匠人的心血与智慧，")
    private String intro;


    /**
     * 服装价格
     */
    @Schema(description = "服装价格", example = "100.00")
    private BigDecimal price;


    /**
     * 所属服装等级
     */
    @Schema(description = "所属服装等级", example = "简约风尚")
    private String clothesType;



    @Serial
    private static final long serialVersionUID = 1L;
}
