package com.cultural.heritage.model.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;

import java.io.Serial;
import java.io.Serializable;
import java.util.Date;


/**
 * 写真预约时间段表
 * @TableName   time_interval
 */
@Data
@TableName("time_interval")
public class TimeInterval implements Serializable {

    /**
     * 预约时间段id
     */
    @TableId(type = IdType.AUTO)
    private Long id;

    /**
     * 时间段
     */
    private String timeSlot;


    /**
     * 最小预约人数
     */
    private Integer minNumber;


    /**
     * 最大预约人数
     */
    private Integer maxNumber;


    /**
     * 预约日期id
     */
    private Long bookingDateId;

    /**
     * 创建时间
     */
    private Date createTime;

    /**
     * 更新时间
     */
    private Date updateTime;

    /**
     * 是否删除
     */
    private Integer isDelete;

    @Serial
    private static final long serialVersionUID = 1L;
}
