package com.cultural.heritage.service.order;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.IService;
import com.cultural.heritage.model.dto.order.OrderAddRequest;
import com.cultural.heritage.model.dto.order.OrderQueryRequest;
import com.cultural.heritage.model.dto.order.capital.OrderMainInfoAddRequest;
import com.cultural.heritage.model.entity.Order;

import java.math.BigDecimal;
import java.util.List;

public interface OrderService extends IService<Order> {


    /**
     * 获取查询条件
     */
    QueryWrapper<Order> getQueryWrapper(OrderQueryRequest orderQueryRequest);


    /**
     * 封装订单详细信息请求体
     */
    OrderAddRequest initOrderMainInfo(OrderMainInfoAddRequest orderMainInfoAddRequest);


    /**
     * 校验订单
     */
    void validOrder(Order order);



    /**
     * 创建通用订单(常规类和服务类商品)
     */
    Long createCommonOrder(OrderMainInfoAddRequest orderMainInfoAddRequest, Long userId, boolean isCartOrder, List<Long> cartIds);


    /**
     * 校验单独购买的商品数据是否准确
     */
    void validSingleGoodOrder(OrderMainInfoAddRequest orderMainInfoAddRequest);



    /**
     * 计算单个商品购买的总金额
     */
    BigDecimal calculateTotalAmount(OrderMainInfoAddRequest orderMainInfoAddRequest);
}
