package com.cultural.heritage.service.wx;


import com.wechat.pay.java.service.payments.jsapi.model.PrepayWithRequestPaymentResponse;
import com.wechat.pay.java.service.payments.model.Transaction;
import com.wechat.pay.java.service.refund.model.Refund;
import com.wechat.pay.java.service.refund.model.RefundNotification;
import jakarta.servlet.http.HttpServletRequest;

import java.io.IOException;
import java.math.BigDecimal;

/**
 * @author 玄德
 */
public interface WeChatService {

    /**
     * 微信支付
     */
    PrepayWithRequestPaymentResponse createPayment(String orderId, String miniOpenId, BigDecimal amount);

    /**
     * 获取支付回调信息
     */
    Transaction getTransactionInfo(HttpServletRequest request);

    /**
     * 支付回调
     */
    boolean paymentCallback(Transaction transaction) throws IOException;

    /**
     * 退款申请
     */
    Refund refundPayment(String orderId, BigDecimal amount);

    /**
     * 获取退款回调信息
     */
    RefundNotification getRefundInfo(HttpServletRequest request);

    /**
     * 退款回调
     */
    boolean refundCallback(RefundNotification refundNotification);

    /**
     * 发送订阅模板消息
     */
    boolean sendSubscribeMessage(String openid, String templateId);

}
