package com.cultural.heritage.rabbit;

import jakarta.annotation.Resource;
import org.springframework.amqp.core.Message;
import org.springframework.amqp.core.MessageBuilder;
import org.springframework.amqp.rabbit.core.RabbitTemplate;
import org.springframework.stereotype.Component;

import java.util.Date;

@Component
public class Producer {

    @Resource
    private RabbitTemplate rabbitTemplate;

    private String exchange = "myExchange";


    public void send(String routingKey, String message) {
        Message msg = MessageBuilder
                        .withBody(message.getBytes())
                        .setHeader("x-delay", 5000)
                        .build();
        System.out.println("发送时间：" + new Date());
        rabbitTemplate.convertAndSend(exchange, routingKey, msg);
    }


//    public void send(String routingKey, String message, MessageDeliveryMode mode) {
//        Message msg = MessageBuilder
//                .withBody(message.getBytes())
//                .setDeliveryMode(mode) // 指定消息是否持久化
//                .build();
//        rabbitTemplate.convertAndSend(exchange, routingKey, msg);
//    }

//    public void send(String message, String routingKey) {
//
//        CorrelationData correlationData = new CorrelationData();
//        correlationData.setId("101"); //UUID.randomUUID().toString()
//        rabbitTemplate.convertAndSend(exchangeName, routingKey, message, correlationData);
//
//        //rabbitTemplate.convertAndSend(exchangeName, routingKey, message);
//    }

}
