package com.cultural.heritage.rabbitmq;

import com.rabbitmq.client.*;
import org.junit.Test;
import org.springframework.web.bind.annotation.RestController;

import java.io.IOException;
import java.util.concurrent.TimeoutException;

@RestController
public class AppTest {

    // 服务器IP
    private String host = "123.249.108.160";

    // RabbitMQ端口
    private int port = 5672;

    // 用户名
    private String username = "chenxinzhi";

    // 密码
    private String password = "yuanteng";

    // 虚拟机名字
    private String vhost = "vhost1";

    // 交换机名字
    private String exchangeName = "myExchange1";

    // 队列名字
    private String queueName = "myQueue1";

    // 路由Key
    private String routingKey = "myRouting1";


    @Test
    public void testProducer() throws IOException, TimeoutException {

        // 创建连接工厂、连接、信道
        ConnectionFactory factory = new ConnectionFactory();
        factory.setHost(host);
        factory.setPort(port);
        factory.setUsername(username);
        factory.setPassword(password);
        factory.setVirtualHost(vhost);
        // 连接
        Connection connection = factory.newConnection();
        // 信道
        Channel channel = connection.createChannel();
        // 创建交换机:直连交换机
        channel.exchangeDeclare(exchangeName, BuiltinExchangeType.DIRECT,
                true, false, null);
        // 创建队列
        channel.queueDeclare(queueName, true, false, false, null);
        // 交换机绑定
        channel.queueBind(queueName, exchangeName, routingKey);
        // 发送消息
        String msg = "Hello, RabbitMQ";
        channel.basicPublish(exchangeName, routingKey, null, msg.getBytes());
        // 关闭
        channel.close();
        connection.close();

    }


    @Test
    public void testConsumer() throws IOException, TimeoutException {
        // 创建连接工厂、连接、信道
        ConnectionFactory factory = new ConnectionFactory();
        factory.setHost(host);
        factory.setPort(port);
        factory.setUsername(username);
        factory.setPassword(password);
        factory.setVirtualHost(vhost);
        // 连接
        Connection connection = factory.newConnection();
        // 信道
        Channel channel = connection.createChannel();
        // 获取消息
        DeliverCallback deliverCallback = (consumerTag, message) -> {
            String msg = new String(message.getBody());
            System.out.println(msg);
        };
        CancelCallback cancelCallback = consumerTag -> {

        };
        channel.basicConsume(queueName, true, deliverCallback, cancelCallback);
    }


}
