package com.cultural.heritage.rabbitmq;

import com.rabbitmq.client.*;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import java.io.IOException;
import java.util.concurrent.TimeoutException;

@SpringBootTest
@RunWith(SpringRunner.class)
public class TestDirect {

    // 服务器IP
    private String host = "123.249.108.160";

    // RabbitMQ端口
    private int port = 5672;

    // 用户名
    private String username = "chenxinzhi";

    // 密码
    private String password = "yuanteng";

    // 虚拟机名字
    private String vhost = "vhost1";

    // 交换机名字
    private String exchangeName = "myExchange1";

    // 队列名字
    private String queueName1 = "myQueue1";

    private String queueName2 = "myQueue2";

    private String queueName3 = "myQueue3";

    // 路由Key
    private String routingKey1 = "myRouting1";

    private String routingKey2 = "myRouting2";

    // 连接对象
    private Connection connection;

    // 信道对象
    private Channel channel;


    public void setUp() throws IOException, TimeoutException {

        // 创建连接工厂、连接、信道
        ConnectionFactory factory = new ConnectionFactory();
        factory.setHost(host);
        factory.setPort(port);
        factory.setUsername(username);
        factory.setPassword(password);
        factory.setVirtualHost(vhost);
        // 连接
        connection = factory.newConnection();
        // 信道
        channel = connection.createChannel();
    }


    @Test
    public void testProducer() throws IOException, TimeoutException {
        // 创建交换机:直连交换机
        setUp();
        channel.exchangeDeclare(exchangeName, BuiltinExchangeType.DIRECT,
                true, false, null);
        // 创建队列
        channel.queueDeclare(queueName1, true, false, false, null);
        channel.queueDeclare(queueName2, true, false, false, null);
        channel.queueDeclare(queueName3, true, false, false, null);
        // 交换机绑定
        channel.queueBind(queueName1, exchangeName, routingKey1);
        channel.queueBind(queueName2, exchangeName, routingKey2);
        channel.queueBind(queueName3, exchangeName, routingKey1);
        // 发送消息
        String msg = "Hello, RabbitMQ";
        channel.basicPublish(exchangeName, routingKey1, null, msg.getBytes());
        String msg2 = "RabbitMQ, Hello";
        channel.basicPublish(exchangeName, routingKey2, null, msg.getBytes());
        // 关闭
        channel.close();
        connection.close();

    }


    @Test
    public void testConsumer() throws IOException, TimeoutException {
        // 获取消息
        setUp();
        DeliverCallback deliverCallback = (consumerTag, message) -> {
            String msg = new String(message.getBody());
            System.out.println(msg);
            System.out.println(msg);
            System.out.println(msg);
            System.out.println(msg);
            System.out.println(msg);
            System.out.println(msg);
            System.out.println(msg);
            System.out.println(msg);
            System.out.println(msg);
            System.out.println(msg);
        };
        CancelCallback cancelCallback = consumerTag -> {

        };
        channel.basicConsume(queueName3, true, deliverCallback, cancelCallback);
    }


}
